﻿Imports System.Diagnostics
Imports System.Text.RegularExpressions

Public Class Program

	Public Shared Sub Main(ParamArray args() As String)
#If True Then
		WithSyntaxCheck1.Main()
#ElseIf True Then
		Simple.Main()
		Simple2.Main()
		WithSyntaxCheck1.Main()
#ElseIf True Then
#End If
	End Sub

End Class
Namespace Simple
	Public Module Module1

		Private _rgxQuotes As New Regex("'.*?'|"".*?""")

		Public Sub Main(ParamArray args() As String)
			Dim s1 = "Where a = ""Upd ' ate"" OR a = 'Ins "" ert'"
			Dim s2 = """aaa'bbb""ccc'ddd""eee'"
			Execute(s1, _rgxQuotes)
			Execute(s2, _rgxQuotes)
		End Sub

	End Module
End Namespace
Namespace WithSyntaxCheck1
	Public Module Module1

		Public Sub Main(ParamArray args() As String)
			Dim s1 = "aaa/*bbb""ccc*/ddd""eee/*ff""ggg"
			Dim s2 = """aaa/*bbb""ccc*/ddd""eee/*ff""ggg"
			Dim s3 = $"aaa/*bbb""c
cc*/ddd""eee""fff[g/*gg]hhh--iiii
jjj"
			Dim s4 = $"aaa--bbb""c
cc*/ddd""eee"
			Dim s5 = $"aaabbb""c
cc*/ddd""eee"
			Execute(s1)
			Execute(s2)
			Execute(s3)
			Execute(s4)
			Execute(s5)
		End Sub

		Private _rgxQuotes As New Regex("'.*?'|`.*?`|\[.*?]|"".*?""|/\*.*?\*/|--.*?\n", RegexOptions.Singleline)
		Private _OpenQuoteMarks As List(Of String) = GetOpenQuoteMarks()
		Private _marker As Char = Convert.ToChar(&HF018) ' ein Zeichen, dass nie vorkommt

		Private Function GetOpenQuoteMarks() As List(Of String)
			Dim pattern = Regex.Unescape(_rgxQuotes.ToString)
			Return (From p In pattern.Split("|"c) Select p.Split("."c)(0)).ToList
		End Function

		Public Function SplitQuotes(s As String) As String()
			Dim splts = _rgxQuotes.Replace(s, $"{_marker}$0{_marker}").Split(_marker)
			For i = 0 To splts.Length - 1 Step 2
				Dim splt = splts(i)
				If _OpenQuoteMarks.Any(Function(evl) splt.Contains(evl)) Then
					Throw New InvalidOperationException("unclosed quote-mark detected")
				End If
			Next
			Return splts
		End Function

		Public Sub Execute(s As String)
			Debug.WriteLine($"{Lf}SplitQuotes() - Input: {s}")
			Try
				Dim splits = SplitQuotes(s)
				For i = 0 To splits.Length - 1
					Dim pre = If((i And 1) = 0, "un", "  ")
					Debug.WriteLine($"{i} {pre}quoted: {splits(i)}")
				Next
			Catch ex As InvalidOperationException
				Debug.WriteLine(ex.Message)
			End Try
		End Sub

	End Module

End Namespace
Namespace Simple2
	Public Module Module1

		Private _rgxQuotes As New Regex("'.*?'|"".*?""|/\*.*?\*/", RegexOptions.Singleline)

		Public Sub Main(ParamArray args() As String)
			Dim s1 = "aaa/*bbb""ccc*/ddd""eee/*"
			Dim s2 = """aaa/*bbb""ccc*/ddd""eee/*"
			Dim s3 = $"aaa/*bbb""c
cc*/ddd""eee/*"
			Execute(s1, _rgxQuotes)
			Execute(s2, _rgxQuotes)
			Execute(s3, _rgxQuotes)
		End Sub

	End Module
End Namespace

Public Module Module2

	Private _marker As Char = Microsoft.VisualBasic.ChrW(&HF018) ' ein Zeichen, dass nie vorkommt

	Public Function SplitQuotes(s As String, rgxQuotes As Regex) As String()
		Dim splts = rgxQuotes.Replace(s, $"{_marker}$0{_marker}").Split(_marker)
		Return splts
	End Function

	Public Sub Execute(s As String, rgxQuotes As Regex)
		Debug.WriteLine($"{Lf}SplitQuotes() - Input: {s}")
		Dim splits = SplitQuotes(s, rgxQuotes)
		For i = 0 To splits.Length - 1
			Dim pre = If((i And 1) = 0, "un", "  ")
			Debug.WriteLine($"{i} {pre}quoted: {splits(i)}")
		Next
	End Sub

End Module