﻿Imports System.Diagnostics
Imports System.Text.RegularExpressions

Namespace WithSyntaxCheckValueTuple
	Public Module Module1

		Private _rgxQuotes As New Regex("'.*?'|"".*?""|/\*.*?\*/|--.*?\n", RegexOptions.Singleline)
		Private Const _marker As Char = Microsoft.VisualBasic.ChrW(&HF018) ' ein Zeichen, dass nie vorkommt

		Public Sub Main(ParamArray args() As String)
			Dim s1 = "aaa/*bbb""ccc*/ddd""eee/*ff""ggg"
			Dim s2 = """aaa/*bbb""ccc*/ddd""eee/*ff""ggg"
			Dim s3 = $"aaa/*bbb""c
cc*/ddd""eee"
			Dim s4 = $"aaa--bbb""c
cc*/ddd""eee"
			Dim s5 = $"aaabbb""c
cc*/ddd""eee"
			Execute(s1)
			Execute(s2)
			Execute(s3)
			Execute(s4)
			Execute(s5)
		End Sub

		Public Function SplitQuotes(s As String) As (splits As String(), [error] As String)
			Dim splts = _rgxQuotes.Replace(s, $"{_marker}$0{_marker}").Split(_marker)
			Dim err = ""
			Dim pattern = Regex.Unescape(_rgxQuotes.ToString)
			Dim evils = (From p In pattern.Split("|"c) Select p.Split("."c)(0)).ToList
			For i = 0 To splts.Length - 1 Step 2
				Dim splt = splts(i)
				Dim iEvil = evils.FindIndex(Function(evil) splt.Contains(evil))
				If iEvil >= 0 Then
					err = $"## unclosed quote-mark {evils(iEvil)} detected at index {i}" : Exit For
				End If
			Next
			Return (splts, err)
		End Function

		Public Sub Execute(s As String)
			Debug.WriteLine($"{Lf}SplitQuotes() - Input: {s}")
			Dim rslt = SplitQuotes(s)
			Dim splits = rslt.splits
			For i = 0 To splits.Length - 1
				Dim pre = If((i And 1) = 0, "un", "  ")
				Debug.WriteLine($"{i} {pre}quoted: {splits(i)}")
			Next
			If rslt.error <> "" Then Debug.WriteLine(rslt.error)
		End Sub

	End Module

End Namespace